/*
 * Fill the fifo, read several times and full is down,
 * write once       -- full should be down
 * then do not write anything, just read -- full should be down
 * $Id: formula5.c 865 2010-07-09 16:48:17Z smrcka $
 */

/* environment */
<%
cnt_en: boolean;
counter: -1..16;
init(counter) := 0;
next(counter) := case {
    reset : 0;
    ~cnt_en : counter;
    (~clk_rd & next(clk_rd) & rd & ~empty) &
    (~clk_wr & next(clk_wr) & wr & ~full): counter;
    (~clk_wr & next(clk_wr) & wr & ~full): counter + 1;
    (~clk_rd & next(clk_rd) & rd & ~empty) : counter -1;
    1: counter;
};
good_full: boolean;
init(good_full) := 0;
next(good_full) := case {
    reset : 0;
    ~clk_wr & next(clk_wr) & (counter<15): next(counter)=15;
    ~clk_wr & next(clk_wr) & (counter=15): 1;
    1: good_full;
};
%>

// reset
reset=1; wr=0; rd=0; clk_rd_val=0; clk_wr_val=0; cnt_en=0;
// unreset, let clk_wr random, wait until full is down
reset=0; clk_rd_val={0,1}; clk_wr_val={0,1}; waitfor(!full);
cnt_en=1;

// fill the fifo
wr=1; waitfor(counter=15);
// partially release the fifo
rd=1; wr=0; waitfor(counter=12);
// turn off most of things
cnt_en=0; wr=0; rd=0; waitfor(!clk_wr & !clk_rd);
// wait until full is down, so read and write is both possible
waitfor(!full);

// write only once (full should be down all time)
writing: clk_wr_val=0; waitfor(!clk_wr);
wr=1; clk_wr_val={0,1}; waitfor(clk_wr);
// do not write anything, only read can be applied (full should be down all the
// time)
wr=0; rd=1;

/*************** STOP ***************/
end: nop;

eventually_end: SPEC EF(state = end);
nofull_when_writing: assert G((state >= writing) -> ~full);
nofull_when_emptying: assert G((state = end) -> ~full);
